#include "stdio.h"
#include "string.h"
#include "stdbool.h"

#define BUFSIZE 0x1000

void filecopy (const char *filename, FILE* fout) {
  char buffer[BUFSIZE];
  bool is_stdin = !strcmp(filename, "-");
  FILE *fin = is_stdin ? stdin : fopen (filename, "r");
  if (fin != NULL) {
    while (! feof(fin)) {
      size_t nread = fread(buffer, sizeof(char), BUFSIZE, fin);
      size_t nwritten = fwrite(buffer, sizeof(char), nread, fout);
    }
    if (!is_stdin) {
      fclose(fin);
    }
  }
  // handle error if fopen failed
}

int main(int argc, char *argv[]) {
  if (argc == 1) {
    filecopy ("-", stdout);
  } else {
    for (int i=1; i<argc; i++) {
      // process all arguments
      filecopy (argv[i], stdout);
    }
  }
  return 0;
}
